import { format, select, csv ,scaleLinear ,max , scaleBand,axisLeft,axisBottom} from 'd3';

const svg = select('svg');
const width = +svg.attr('width');
const height = +svg.attr('height');

const render =data=>{
	const xValue = d => d.population;
	const yValue = d => d.country;
	const margin = { top:20, right :20 , bottom : 20, left : 100};
	const innerWidth = width-margin.left-margin.right;
	const innerHeight  = height-margin.top-margin.bottom;

	const xScale = scaleLinear()//线性比例尺，domain()是输入域映射到range()是输出域中
		.domain([0, max(data, xValue)])
		.range([0,innerWidth]);

	//d3.scaleBand()只针对domain()中的数据集映射相应的值
	const yScale = scaleBand()// 序数比例尺，不是一个连续性的比例尺，domain()中使用一个数组，不过range()需要是一个连续域
		.domain(data.map(yValue))
		.range([0,innerHeight])
  	.padding(0.3);

  const xAxisTickFormat = number =>
  	format('.3s')(number).replace('G','B');
  
	const xAxis = axisBottom(xScale)
	.tickFormat(xAxisTickFormat);
  
   const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
    //注意translate的引号不是英文单引号，是反单引号
    //yAxis(g.append('g'));
   g.append('g').call(axisLeft(yScale));//画坐标轴，y
   g.append('g').call(axisBottom(xAxis))
     .attr('transform', `translate(0,${innerHeight})`);//使x轴移至底部
    

	g.selectAll('rect')//告诉浏览器找到svg元素并在其中查找任何矩形
		.data(data)//将数据绑定到选择的data中
		.enter().append('rect')//如果没有找到与相应数据个数对应的矩形